! -------------------------------------------------------------------------
!   menus_it.h          Estensione per avere menu' migliori e piu' semplici
!                                                      Graham Nelson 961113
!     added one-line correction to support Strict mode   Roger Firth 030303
!     traduzione e adattamento all'italiano           Paolo Lucchesi 031027
!
!   Un menu' e' un albero di oggetti di classe Option. Un menu' (oggetto di
!   classe Menu) e' un opzione (Option) che lancia un nuovo menu' quando
!   viene scelta. Per scegliere l'opzion O, inviate il messaggio:
!
!       O.select();
!
!   Cosi' per iniziare una sessione di menu', inviate questo messaggio
!   al menu' principale.
!
!   Ecco una semplice struttura di menu':
!
!       Menu "Istruzioni per giocare a Mordred";
!       Menu   -> "Come giocare alle avventure testuali;
!       Option -> -> "Guardarsi intorno
!                     with description "Io sono i tuoi occhi ...";
!       Option -> -> "Raccogliere e Lasciare"
!                     with description "Se trovi degli oggetti ...";
!       Option -> "A proposito dell'autore
!                  with description "L'autore e' nato a ...";
!
!   I menu' prodotti con questo codice sono divisi automaticamente in
!   pagine, in modo da poter stare sempre nello schermo, qualunque sia
!   la dimensione di quest'ultimo e per quante opzioni ci siano.
!
!   Notate che, dato che gli oggetti possono sempre essere mossi durante
!   il gioco, e' facile creare nuove strutture di menu' che si adattino
!   alle circostanze del momento. (Per esempio, un menu' di aiuto che dia
!   suggerimenti solo sugli enigmi attualmente in corso.)
!
!   Potete invece scrivere una routine che riceva il messaggio "description".
!   Cosi' il testo stampato quando viene scelta un'opzione puo' cambiare.
!
!   Se una routine del genere restituisce 2, allora il gioco non chiede al
!   giocatore di premere un tasto prima di tornare al menu'. Se la routine
!   restituisce 3, allora l'intero menu' viene immediatamente chiuso.
!  
!   Infine, potete sempre fornire la vostra routine "select" per un'opzione.
!   Le regole per i valori restituiti sono le stesse; quello che cambia e'
!   che in questo modo lo schermo non sara' pulito e non verra' mostrata
!   l'intestazione quando l'opzione viene scelta. (Non accadra' niente di
!   visibile a meno che non siate voi a farlo). La classe SwitchOption e'
!   un'esempio di cosa potete fare con questa possibilita':
!
!       Menu "Impostazioni di gioco;
!       SwitchOption -> FullRoomD   "descrizioni complete" has on;
!       SwitchOption -> WordyP      "prompt esplicito";
!       SwitchOption -> AllowSavedG "salvataggi permessi" has on;
!
!   Scegliere una di queste opzioni switch la cambia tra acceso (on) e
!   spento (~on). Nel vostro programma potete verificare
!
!       if (WordyP has on) ...
!
!   e in questo modo controllare lo statu attuale.
! -------------------------------------------------------------------------

Ifndef PKEY__TX;

Constant LIB_PRE_63;

!   Se non fossero definite...

Constant NKEY__TX     = "S = successivo";
Constant PKEY__TX     = "P = precedente";
Constant QKEY1__TX    = " R = riprendi gioco";
Constant QKEY2__TX    = "R = menu precedente";
Constant RKEY__TX     = "RETURN = leggi argomento";

Constant NKEY1__KY    = 'S';
Constant NKEY2__KY    = 's';
Constant PKEY1__KY    = 'P';
Constant PKEY2__KY    = 'p';
Constant QKEY1__KY    = 'R';
Constant QKEY2__KY    = 'r';

Endif;

Global screen_width;
Global screen_height;

! Array ForUseByOptions string 128;
! Changed by Roger Firth to match the code in Section 44 of the DM4.
Array ForUseByOptions -> 129;
Class Option
 with emblazon
      [ bar_height page pages temp;

          screen_width = 0->33;

          !   Clear screen:

          @erase_window $ffff;
          @split_window bar_height;

          !   Black out top line in reverse video:
          @set_window 1;
          @set_cursor 1 1;
          style reverse; spaces(screen_width);

          if (standard_interpreter == 0)
              @set_cursor 1 1;
          else
          {   ForUseByOptions-->0 = 128;
              @output_stream 3 ForUseByOptions;
              print (name) self;
              if (pages ~= 1) print " [", page, "/", pages, "]";
              @output_stream -3;
              temp = (screen_width - ForUseByOptions-->0)/2;
              @set_cursor 1 temp;
          }

          print (name) self;
          if (pages ~= 1) print " [", page, "/", pages, "]";

          return ForUseByOptions-->0;
      ],
      select
      [;  self.emblazon(1, 1, 1);

          @set_window 0; font on; style roman; new_line; new_line;

          if (self provides description)
              return self.description();

          "[Niente testo per questa opzione.]^";
      ];

Class Menu class Option
 with select
      [ count j obj pkey  line oldline top_line bottom_line
                            page pages options top_option;

          screen_width = 0->33;
          screen_height = 0->32;
          if (screen_height == 0 or 255) screen_height = 18;
          screen_height = screen_height - 7;

          options = 0;
          objectloop (obj in self && obj ofclass Option) options++;
          if (options == 0) return 2;

          pages = 1 + options/screen_height;

          top_line = 6;

          page = 1;

          line = top_line;

          .ReDisplay;

          top_option = (page - 1) * screen_height;

          self.emblazon(7 + count, page, pages);

          @set_cursor 2 1; spaces(screen_width);
          @set_cursor 2 2; print (string) NKEY__TX;
          j = screen_width-14; @set_cursor 2 j; print (string) PKEY__TX;
          !PL,it was: j = screen_width-12; @set_cursor 2 j; print (string) PKEY__TX;

          @set_cursor 3 1; spaces(screen_width);
          @set_cursor 3 2; print (string) RKEY__TX;
          j = screen_width-19; @set_cursor 3 j; 
          !PL,it was: j = screen_width-17; @set_cursor 3 j; 

          if (sender ofclass Option)
              print (string) QKEY2__TX;
          else
              print (string) QKEY1__TX;
          style roman;

          count = top_line; j = 0;
          objectloop (obj in self && obj ofclass Option)
          {   if (j >= top_option && j < (top_option + screen_height))
              {   @set_cursor count 6;
                  print (name) obj;
                  count++;
              }
              j++;
          }
          bottom_line = count - 1;
          oldline = 0;

          for(::)
          {   !   Move or create the > cursor:

              if (line~=oldline)
              {   if (oldline~=0) { @set_cursor oldline 4; print " "; }
                  @set_cursor line 4; print ">";
              }
              oldline = line;

              @read_char 1 -> pkey;

              if (pkey == NKEY1__KY or NKEY2__KY or 130)
              {   !   Cursor down:
                  line++;
                  if (line > bottom_line)
                  {   line = top_line;
                      if (pages > 1)
                      {   if (page == pages) page = 1; else page++;
                          jump ReDisplay;
                      }
                  }
                  continue;
              }

              if (pkey == PKEY1__KY or PKEY2__KY or 129)
              {   !   Cursor up:
                  line--;
                  if (line < top_line)
                  {   line = bottom_line;
                      if (pages > 1)
                      {   if (page == 1)
                          {   page = pages;
                              line = top_line
                                     + (options % screen_height) - 1;
                          }
                          else
                          {   page--; line = top_line + screen_height - 1;
                          }
                          jump ReDisplay;
                      }
                  }
                  continue;
              }

              if (pkey==QKEY1__KY or QKEY2__KY or 27 or 131) break;

              if (pkey==10 or 13 or 132)
              {   count = 0;
                  objectloop (obj in self && obj ofclass Option)
                  {   if (count == top_option + line - top_line) break;
                      count++;
                  }

                  switch(obj.select())
                  {   2: jump ReDisplay;
                      3: jump ExitMenu;
                  }

                  #ifdef LIB_PRE_63;
                  print "[Per favore premi SPAZIO.]^";
                  #ifnot;
                  L__M(##Miscellany, 53);
                  #endif;
                  @read_char 1 -> pkey;
                  jump ReDisplay;
              }
          }

          .ExitMenu;

          if (sender ofclass Option) return 2;

          font on; @set_cursor 1 1;
          @erase_window $ffff; @set_window 0;
          new_line; new_line; new_line;
          if (deadflag==0) <<Look>>;
          return 2;
      ];

Class SwitchOption class Option
  with short_name
       [;  print (object) self, " ";
           if (self has on) print "(on)"; else print "(off)";
           rtrue;
       ],
       select
       [;  if (self has on) give self ~on; else give self on;
           return 2;
       ];

! ------------------------------------------------------------------------
