! phtalkoo_it.h: libreria object/oriented per il sistema di conversazione
!             a scelte multiple di Photopia
!
! Traduzione di phtalkoo.h
! basatp su phototalk.inf di Adam Cadre, il sorgente object-oriented
! dei dialoghi di Photopiae  modificato in phtalkoo.h da David Glasser 
! 21-Lug-1999. Tradotto in italiano di Paolo Lucchesi.
!
! Questo file  una libreria basata sul sistema di conversazione di
! Photopia. I suoi principi differiscono di poco da flags.h, il
! modulo di flag binari di Adam.
!
! Questa libreria deve essere inclusa subito dopo parser.h
! Inoltre dopo la definizione della grammatica (italiang.h), si
! devono aggiungere queste righe:
!        Extend 'parla' first
!                * 'a'/'ad'/'all^'/'allo'/'alla'/'al'/'agli'/'ai'/
!                  'alle'/'con' creature
!                                                 -> TalkTo;   
!
! Ogni NPC deve essere di classe Character, e deve avere le funzioni
! SayQ(x) e Respond(x), che stampano l'x-esimo titolo e la x-esima
! risposta; inoltre Respond normalmente fa altre cose, oltre a 
! stampare la risposta.
!
! Ogni NPC deve avere anche una funzione InitQuips(), che deve
! inizializzare (vedi sotto) i 'quip' (flag che indicano se una certa 
! coppia frase/risposta e' attiva o no) che sono attivi di default 
! (all'inizio dell'avventura). Si dovrebbe mettere la seguente riga
! nella funzione initialize (definendo la variabile o, ovviamente)
!   objectloop (o ofclass Character) { o.InitQuips(); }
!
! NPC.SetQuip(42, 1) attiva il 42-esimo quip di NPC, NPC.SetQuip(42, 0)
! lo disattiva. NPC.QuipOn(42) e NPC.QuipOff(42) sono abbreviazioni
! per gli stessi comandi. NPC.QuipsOff(N, a, b, ...) disattiva N quips
! indicati dagli argomenti successivi (a, b, ...); N varia da 0 a 6, 
! visto che inform accetta al massimo 7 argomenti per funzione.
! NCP.QuipsOn(N, a, b, ...) fa esattamente cio' che pensate.
! Finalmente NPC.TestQuip(42) restituisce il valore (1 o 0) del
! 42-esimo quip.
!
! Di default si possono usare 56 quip, numerati da 0 a 55.
!
! NOTA PER CHI HA GIA USATO PHOTOTALK.INF: nel file di Adam, QuipOn
! veniva usato per testare il valore, e non c'erano abbreviazioni 
! per settare il quip. Ora TestQuip fa il test, e QuipOn setta.
!
! Potete aggiungere le routine di life e/o orders alla classe
! Character, o modificare i messaggi sottostanti.
!
! Se un personaggio ha bisogno di piu' di 56 quip, potete campiare
! (o nella classe o overloadando il personaggio) la definizione di
! qflag fino a N/8 zeri, e MAXQUIP a N-1, dove N e' il numero di
! quip di cui avete bisogno (ed e' multiplo di 8).
!
! Volendo potete sostituire (replace) alcune (o tutte) routine come
! AskSub, AskForSub, TellSub, GiveSub, ShowSub e AnswerSub con:
!      [ FooSub; "Usate >PARLA A PERSONA per interagire."; ];
! e potete aggiungere questo nella classe Character
!      orders [; "Usate >PARLA A PERSONA per interagire."; ];
!
! Variante introdotta nella versione italiana: Se si definisce la
! costante PH_SINGLE_PRESS, la libreria accetta come scelta la
! pressione di un singolo tasto (numerico). Ovviamente in questo
! caso ci possono essere in ogni istante solo 9 opzioni di dialogo 
! possibili (solo nove quip attivi).
!
! Alla fine del file trovate un'esempio (in commento, ovviamente)

Class Character
   with
    qflag 0 0 0 0 0 0 0, ! 56 dovrebbe essere abbastanza
    MAXQUIP 55,  ! come una costante
    before [x z ok selected;
        TalkTo:
        for (x=0 : x <= self.MAXQUIP : x++) {
            if (self.TestQuip(x)) { ok++; }
        }
        
        if (ok > 0) {
            print "Cosa vuoi dire?^^";

            ! Lista le linee tra cui puoi scegliere
            
            for (x=0: x <= self.MAXQUIP: x++) {
                if (self.TestQuip(x)) {
                    z++;
                    print "[", z, "] ";
                    self.SayQ(x);
                }
            }

            ! Accetta la scelta
     
            new_line;
            do {
                print "Scegli un'opzione, o 0 per non dire nulla >> ";
              #Ifdef PH_SINGLE_PRESS;
                @read_char 1 -> selected;
                print (char) selected, "^";
                selected=selected-48;
              #Ifnot;
                read buffer parse DrawStatusLine;
                selected = TryNumber(1);
              #Endif;
            } until ((selected >= 0) && (selected <= z));
            if (selected == 0) print "^Decidi di tenere la bocca chiusa.^";

            if (selected ~= 0) {
                ok = 0; new_line;
                for (x=0: x <= self.MAXQUIP: x++) {
                    if (self.TestQuip(x)) {
                        ok++;
                        if (ok == selected) {
                            self.Respond(x);
                        } !se non e' quella scelta
                    } !se non e' attiva
                } !alla fine della lista
            } !se non vogliamo risposte
            
            rtrue;
        } !se non ci sono quip
        
        "Non ti sovviene niente di particolare da dire.";
    ],
    SetQuip [ line onoff     y z;
        if (line > self.MAXQUIP) {
            "Oh, no!  Quip troppo alto in ", (the) self, ".SetQuip! [BUG]";
        }
        y = line / 8;  ! y bytecount
        z = line % 8;  ! z bitnum
        z = TwoPower(z);  ! byte con solo un bit settato
        if (onoff == 1) {
            self.&qflag->y = self.&qflag->y | z; }
        if (onoff == 0) {
            self.&qflag->y = self.&qflag->y & ~z; }
        ],
    QuipOn [line; self.SetQuip(line, 1); ],
    QuipOff [line; self.SetQuip(line, 0); ],
    QuipsOn [n a b c d e f; ! questa funzione puo' essere migliorata
        if ((n < 0) || (n > 6)) { ! 0 ignorato
            "QuipsOn chiamata con primo argomento ", n, "!";
        }
        if (n == 0) return; self.QuipOn(a);
        if (n == 1) return; self.QuipOn(b);
        if (n == 2) return; self.QuipOn(c);
        if (n == 3) return; self.QuipOn(d);
        if (n == 4) return; self.QuipOn(e);
        if (n == 5) return; self.QuipOn(f);
        ],
    QuipsOff [n a b c d e f; ! this function can probably be written better
        if ((n < 0) || (n > 6)) { ! 0 is ignored
            "QuipsOff chiamata con primo argomento ", n, "!";
        }
        if (n == 0) return; self.QuipOff(a);
        if (n == 1) return; self.QuipOff(b);
        if (n == 2) return; self.QuipOff(c);
        if (n == 3) return; self.QuipOff(d);
        if (n == 4) return; self.QuipOff(e);
        if (n == 5) return; self.QuipOff(f);
        ],
    TestQuip [line      y z;
        if (line > self.MAXQUIP) {
            "Oh, no!  Quip troppo alto in ", (the) self, ".TestQuip! [BUG]";
        }
        y = line / 8;
        z = line % 8;
        z = TwoPower(z);
        if (self.&qflag->y & z == z) { rtrue; }
        rfalse;
    ],
    SayQ [; "Eh? [BUG]";],
    Respond [; "Non so cosa dire. [BUG]"; ],
    InitQuips [; "~La mia InitQuips  in overload,~ dice ", (the) self, ". [BUG]";],

    has animate
;

[ TalkToSub;  ! Un metodo di comunicazione per dominarli
   if (noun == player) "Parli da solo?.";
   if (~~(noun ofclass Character)) "Forse dovresti provare a parlare con una persona.";
                  print (The) noun;
                  if (noun has pluralname) print " non sembrano";
                          else print " non sembra";
                              " interessato.";
];

[ TwoPower a;
    switch(a) {
    0:  return $$000000001;
    1:  return $$000000010;
    2:  return $$000000100;
    3:  return $$000001000;
    4:  return $$000010000;
    5:  return $$000100000;
    6:  return $$001000000;
    7:  return $$010000000;
    }
    "Errore: TwoPower out of range: ", a, "!"; 
];

! Constant Story "Gino Marino";
! Constant Headline "^Un test interattivo di phtalkit.h^
!               Copyright (c) 1998 by David S. Glasser.^
!               Tradotto da Paolo Lucchesi";

! Include "parser.h";               

! Global PH_SINGLE_PRESS;
! Include "phtalkit.h";

! Include "verblib";
! Include "replace";

! [ Initialise o;
!   location = here;
!   print "^Gino Marino!^^";
!   objectloop (o ofclass Character) { o.InitQuips(); }
! ];

! Object here "Casa di Gino Marino"
! with description "Sei a casa di Gino Marino." has light;

! Character -> GinoMarino "Gino Marino"
!   with name 'gino' 'marino',
!   description "Questo  Gino. E' tuo amico",
!   SayQ [line; switch (line) {
!           0: "Chi sei?";
!           1:   "Perch Inform ti odia?";
!           2:     "Probabilmente ti sei dimenticato un punto e virgola.";
!           3:     "Non mi interessa.";
!           4:   "Ha, ha. Inform ti odia.";
!           5: "Ti piacerebbe una scimmia?";
!           6:   "Solo ai pazzi piacciono le scimmie.";
!           7:   "No, ho detto ~una scimmia~, non ~scimmie~.";
!           8:   "Anche a me piacciono le scimmie.";
!        }
!        ],
!   Respond [line; switch (line) {
!           0:  self.QuipOff(0); self.QuipsOn(2, 1,4);
!               "~Mi chiamo Gino Marino, e Inform mi odia.~";
!           1:  self.QuipOff(1); self.QuipsOn(2, 2,3);
!               "~Ho provato a compilare, e mi ha dato 40 errori.~";
!           2:  deadflag = 2; ! no need to set quips when the game's over
!               "~Grazie davvero! Sei un grande!~";
!           3,4:deadflag = 1;
!               "~Ti Odio!~^Gino ti uccide.";
!           5:  self.QuipOff(5); self.QuipsOn(3, 6,7,8);
!               "~Certo. Mi piacciono le scimmie~";
!           6:  deadflag = 1;
!               "~Ti Odio!~^Gino ti uccide.";
!           7:  deadflag = 1;
!               "~Odio le persone pedanti!~^Gino ti uccide.";
!           8:  deadflag = 2;
!               "~Allora possiamo essere amici!~";
!           }
!   ],
!   InitQuips [; self.QuipsOn(2, 0,5); ],
!   
!   has male proper
! ;

! Include "ItalianG";

! ! infine modifichiamo la grammatica...
! Extend 'parla' first
!                 * 'a'/'ad'/'all^'/'allo'/'alla'/'al'/'agli'/'ai'/
!                   'alle'/'con' creature
!                                                  -> TalkTo; 
